local concat,insert,format = table.concat,table.insert,string.format

local db = {}
local sha256 = require'sha256'

db.view = { -- signup
  {"uname","Login",sz = 30,true},
  {"pw","Password",sz = 30,ht = 'PW',true},
  {"confirm","Confirm Password",sz = 30,ht = 'PW',true},
  mod = "users",
  submit = {
    {"login","Submit",{signup=1},'submit'},
  },
  class='signup',
}

local html = [[
<div class="section"><section class="section-space"><div class="container">
  <center>
  <p>
  <form id="edfrm" name='login' action="$action" method="post">
  <div class="login">
      <div class="capt">$caption</div>
      <div class="field">
        <label for="uname">$login</label>
        <input id='uname' maxlength='40' name='uname'/>
      </div>
      <div class="field">
        <label for="pw">$pw</label>
        <input id="pw" type="password" maxlength="40" name="pw"/>
      </div>

      <div class="register">
       $register
      </div>

      <div class="enter">
         <input id="enter" type="submit" value="$enter" name="enter"/>
      </div>

  </div>
  <script>
    ;(function(){
      $('.login .enter #enter').click(function(e){
        $('.login #uname').attr('required',true);
        $('.login #pw').attr('required',true);
        return acall('login',{'act':'enter'});
      });

      if( $('.login .register a') != undefined){
        $('.login .register a').click(function(e){
          $('.login #uname').attr('required',false);
          $('.login #pw').attr('required',false);
        });
      }
      window.scrollTo(100,0);
      $('.login #uname').focus();
    })();
  </script>
  </form>
  </p>

  <p>
    <img class="board" src='$board' alt="" width="285"/>
  </p>

  </center>
</div></div></div>
]]

local function valid(email)
  if not string.match(email,"[^%s]+@[^%s]+%.[^%s]+") then
    return {'Your email address is ivalid. Please enter a valid address'}
  end
  return 'ok'
end

local function send(self,email,code,ispw) -- activate or pw
    local pw = code
    if not ispw then
      pw = nil
    end
    local mail = setmetatable(require("apps.mail.mods.mails"),{__index=self})
    local link = concat{self.conf.url or '',"/",self.conf.idx,"?mod=login&act=activate&code=",code}

    local plain = lang._SIGNUP and lang._SIGNUP.mail and lang._SIGNUP.mail.plain or 
                  [[Copy link bellow to activate login %s ]]
    plain = format(plain,link)
    if pw then
        plain = lang._LOGIN and lang._LOGIN.password and lang._LOGIN.password.plain or [[password: %s]]
        plain = format(plain,pw)
    end

    local html = lang._SIGNUP and lang._SIGNUP.mail and lang._SIGNUP.mail.html or
      [[<a href="%s"><span>Click here</span></a>
      or follow this link to activate login<div>%s</div>]]
    html = format(html,link,self.util:escape(link))
    if pw then
       html = lang._LOGIN and lang._LOGIN.password and lang._LOGIN.password.html or [[password: %s]]
       html = format(html,pw)
    end
    html = concat{'<div class="section"><section class="section-space"><div class="container">',
      html,
      "</div></div></div>"}

    local data = {subject=pw and 'Password' or 'Login',plain = plain, html = html}
    local res = mail:send(data,email)
    if res == 'ok' then
      return 'ok'
    else
      return {concat{'error mail:',res}}
    end
end

local function enter(self)
    local uname = string.gsub(params.uname,"'","''")
    local pw = string.gsub(params.pw,"'","''")
    local msg = 'Invalid username'
    local qry = concat{"select users.login,users.pw,users.admin,ifnull(users.lang,'') as lang,",
    "roles.pages,users.rowid as rid,home,hex(randomblob(25)) as key from users ",
    "left join roles on users.role = roles.rowid where users.active = 1 and login = '",uname,"'"}
    for row in self.conn:nrows(qry) do
      local key = row.key
      if row.pw ~= pw and row.pw ~= sha256(pw) then
        msg = 'Invalid password'
        break 
      end
      local qry = concat{"update users set cookie = '",key,"' where rowid = ",row.rid}
      if self.conn:exec(qry) == 0 then
        cookie("yokeid",key)
        self.user:init(row)
        --if self.conf.js then
        --  local menu = self:enter() or {}
        --  params.act = 'find'
        --  return self:page(menu[2] and menu[2][1],{menu=menu[1],door=menu[3],nav=menu[4]})
        --else
        --  return self:start()
        --end
        return 'ok'
      else
        return self.conn:errmsg()
      end
    end
    return msg
end


function db:main(out)

  local info = params.uname and "Login failed" or lang.Log or "Log"
  local action = concat{self.conf.idx,"?mod=login&lynx=true"}
  local reg = ''
  local role = 0
  local signup = self.conf.signup
  if signup then
    if type(signup) == 'string' then
      for rid in self.conn:urows(concat{"select rowid from roles where name = '",signup,"'"}) do
        reg = self:link("login",lang.Signup or "Signup",{act='new'})
        role = rid
      end
    else
      reg = self:link("login",lang.Signup or "Signup",{act='new'})
    end
  end
  local face = self.conf.face
  local path = self.conf.path
  for content in self.conn:urows(concat{"select content from pages where id = '",'login',"'"}) do
    html = content
  end

  local form = self.util:sub(html,{
     action = action,
     caption = info,
     login = lang.Login or "Login",
     pw = lang.Password or "Password",
     enter = lang.Enter or "Enter",
     register = reg,
     board = face and face.board and concat{path,"/face/",face[1],"/img/",face.board}
                  or concat{path,"/site/face/img/board.jpeg"},

  })

  if params.act == "activate" then
    local qry = concat{"select rowid from users where ifnull(active,0)+0 <> 1 and cookie = '",params.code or '',"'"}
    for rowid in self.conn:urows(qry) do
        qry = concat{"update users set active=1 where rowid=",rowid}
        self.conn:exec(qry)
        return form
    end
    return [[
          <div class="section"><section class="section-space"><div class="container">
            <script>window.History.replaceState(null,null,'.');</script>
            <center>
              <p style="color:red">
                Activation is not valid
              </p>
            </center>
          </div></section></div>
    ]]
  elseif params.act == "password" and params.uname then
        local uname = params.uname
        local uid,pw = nil,nil
        local res = valid(uname)
        if res ~= 'ok' then
          return res
        end
        local qry = concat{"select rowid,login,pw,lower(hex(randomblob(3))) as newpw ",
                           "from users where ifnull(active,0)+0 = 1 and login = '",uname,"'"}
        for rowid,uname,password,newpw in self.conn:urows(qry) do
          uid = rowid
          pw = password -- or newpw
        end
        if not uid then
          return {lang._LOGIN and lang._LOGIN.nologin or concat{"No active user",": ",uname}}
        end
        if self.conf.apps.mail then
            local res = send(self,uname,pw,'pw')
            if res ~= 'ok' then
              return res
            else
              qry = concat{"update users set pw = '",pw,"' where rowid = ",uid}
              if self.conn:exec(qry) == self.dbm.OK then
                local msg = concat{[[<div class="section"><section class="section-space"><div class="container">]],
                  (lang._LOGIN and lang._LOGIN.password.message or
                   "<h1>Password has been sent to you, please check your mailbox</h1>"),
                  [[</div></div></div>]],
                }
                return msg
              else
                return {'Password error mail'}
              end
            end
        else
            return {'No mail in apps'}
        end
  end
  local act = params.act
  params.act = 'edit'

  if signup and params.signup then
      if params.uname and params.pw and params.confirm then
        local uname = params.uname:gsub(' ','')
        local pw = params.pw:gsub(' ','')
        if pw ~= params.confirm or pw == '' then
          return {lang._SIGNUP and lang._SIGNUP.confirmation or "Confirmation password does not match"}
        elseif uname ~= '' then
          local qry = concat{"select login from users where login = '",uname,"'"}

          for row in self.conn:urows(qry) do
            local mes = lang._SIGNUP and lang._SIGNUP.used or 'The email address %s is already in use'
            mes = format(mes,uname)
            return {mes}
          end

          qry = concat{"insert into users (login,pw,role,active) values ('",uname,"','",
                                                pw,"',",role,",1)"}

          if self.conf.apps.mail then
            if not string.match(uname,"[^%s]+@[^%s]+%.[^%s]+") then
              return {'Your email address is ivalid. Please enter a valid address'}
            end
            local code = sha256(uname)
            local res = send(self,uname,code)
            if res ~= 'ok' then
              return res
            else
              qry = concat{"insert into users (login,pw,role,cookie) values ('",uname,"','",pw,"',",role,",'",code,"')"}
              if self.conn:exec(qry) == 0 then
                local msg = concat{[[<div class="section"><section class="section-space"><div class="container">]],
                  (lang._SIGNUP and lang._SIGNUP.activate or "<h1>An activation link has been sent to you, please check your mailbox</h1>"),
                  [[</div></div></div>]],
                }
                return msg
              else
                return {'Signup error mail'}
              end
            end
          elseif self.conn:exec(qry) == 0 then
            return form
          else
            return {'Signup error'}
          end
          --
        end
      end
  elseif act == 'enter' then
    return {self.user:enter()}
  elseif act ~= 'new' or not signup then
    return form
  end
  --signup
end

return db

 
