------------------------------
-- yoke (c) nico@yokerp.com --
------------------------------
local sha256 = require'sha256'

local db = {}
local concat,insert = table.concat,table.insert

db.view = {
  {"pw","Password",sz = 30,ht = 'PW'},
  {"lang","Lang",ht = "SELECT",rf="langs"},
  {"menu",  "Menu", ht = 'SELECT',rf={{'left',"Left"},{'top','Top'}}},
  {"home" ,"Home", ht = "SELECT", rf = {{"home",ht="SHOW"}},rt="pages"},
  {"signature" ,"Signature", ht = "TEXTAREA"},
  mod = "users",
  nodelete = true
}

function db:delete() end -- no delete

db.field = {
  home = function(self,row)
    local sel = {}
    local qry = {"select id,name from pages ",
    "where active = 1 and access > 1 and menu+0 > 0 "}
    if (self.user.pages or "") ~= "" then
      local pages = {}
      for pg in string.gmatch(self.user.pages,"(%w+):0") do pages[#pages+1] = pg end
      if #pages > 0 then
        insert(qry,concat{" and id not in ('",concat(pages,"','"),"')"})
      end
    end
    insert(qry," order by menu")
    for id,name in self.conn:urows(concat(qry)) do
      insert(sel,{id,name,(row and id == row.home) and true})
    end
    return sel
  end
}

function db:update(row)
  if row.pw and string.len(row.pw) ~= 64 then
    --if row.pw == 'admin1' and self.user.login == 'admin' then row.admin = 1 end
    row.pw = sha256(row.pw)
  end
end

function db:main()
  if not self.user.id or params.act == "delete" then
    return true
  else
    params.recno = self.user.id
    if not params.act then  params.act = "show" end
  end
end

return db
