------------------------------
-- yoke © luamani@yahoo.com --
------------------------------

local db = require"yoke.site.form.base"
local concat = table.concat
local ver = _VERSION:match('%s([^%s]+)$')

local function page(self)
  local mod = params.mod
  if params.popup then
    return db.form.snap:run()
  elseif mod and mod ~= '' and self.conf.js then
    if params.onepage then
      return self:onepage()
    else
      return self:page(mod)
    end
  else
    return db.form.page:run()
  end
end

function db:site()
  self:open()
  local ok,page = xpcall(page,function(msg) --assert
    msg = msg or ''
    if (msg:match('no such column:') or msg:match('no such table:') or msg:match('has no column'))
                                          and not self.initialized then
      self:init(msg)
      self:close()
      return self:site()
    else
      debug.log(msg)
      return debug.traceback(msg)
    end
  end,self)
  self:close()
  if not ok and self.conf.cli then print(page) end
  return page
end

local function yard(db)
  local yard = require'yoke.snap.yard.init':new({
    port = arg[2] or '8081',
    location = '/',
    timeout = ver == '5.3' and 5.0 or 0.1 , -- 5.0 for android
  }):run(db)
end

return function(conf)
  local luarocks = conf.luarocks
  package.path = concat{package.path,";",luarocks,"/share/lua/",ver,"/?.lua"}
  package.cpath = concat{package.cpath,";",luarocks,"/lib/lua/",ver,"/?.so"}

  local lib = concat{conf.root,'/yoke'}
  package.path = concat{package.path,";",lib,"/?.lua"}
  package.cpath = concat{package.cpath,";",lib,"/?.so"}

  local snap = concat{conf.root,'/snap'}
  package.path = concat{package.path,";",snap,"/?.lua"}
  package.cpath = concat{package.cpath,";",snap,"/?.so"}

  if python and (conf.idx or ''):match('%.lua$') then
    conf.idx = conf.idx:gsub('.lua','.py')
  end

  db.conf = conf
  if not arg then
    print(db():site()) --ext serv
  elseif arg[1] == 'cli' or arg[2] == 'cmd' then
    db:subclass('term'):include(require"yoke.snap.term"):run()
  elseif arg[1] == 'd' then --int serv
    yard(db)
  else --cgi
    require"yoke.snap.http"(db)
  end

end

