------------------------------
-- yoke © luamani@yahoo.com --
------------------------------

local concat,insert,format = table.concat,table.insert,string.format

local db = {}

function db:run()
  local hist = {}
  if not params then params = {} end
  self:initialize()
  while true do
    debug.log(params)

    self:site()

    if not params.mod and self.conf.home then
      params.mod = self.conf.home
      hist[#hist+1] = params
    end

    if arg[2] and arg[2] ~= 'cmd' then print("cmd:",arg[2]) break end

    hist.back = params.act == "delete"
    params = {shift=params.shift}
    if hist.back then
    elseif self.menu[2] then
      self.menu[2].loop()
    elseif self.menu[1] then
      self.menu[1].loop()
      hist = {}
    else
      break
    end

    if self.menu[2] and (self.menu.back or hist.back) and params.act ~= 'find' then
      table.remove(self.menu,2)
      if #hist > 1 then
        params = hist[#hist-1]
        table.remove(hist,#hist)
      end
    elseif not params.mod then break
    else
      local act = params.act
      if act ~= "checkbox" and act ~= "update" and act ~= "download" then --todo
              --and not (act == 'new' and hist[#hist] and hist[#hist].act ~= 'show') then --todo new
        --debug.log('HIST ACT')
        --debug.log(hist[#hist] and hist[#hist].act)
        hist[#hist+1] = params
      end
    end
    self.menu.back = nil
  end
  print("Bye.")
  os.exit()
end

function db:initialize()
  self.super.term = self
  self.super:initialize()
  self.menu = require"yoke.snap.term.menu"
  if self.menu then 
    self.conf.cli = {}
  end
  if arg and arg[2] then
    for k,v in string.gmatch(arg[2],"([^,=&]+)=([^,=&]*),?") do params[k]=v end
  end
  cookie = function(key,val)
    local fd = io.open(concat{self.conf.db,".cli"},val and "w" or "r")
    if not fd then return end
    if val then
      fd:write(concat{key,"=",val})
      fd:close()
    else
      local line = fd:read("*L")
      local k,v = line:match("(%w+)=(%w+)")
      if k == key then return v end
    end
  end
  local ok,fd = pcall(io.popen,"stty size","r")
  if ok then self.menu.rows = string.match(fd:read("*l") or "","^%d+") - 4 end
  self.conf.js = false
  return self
end

function db:main(content,menu,items)
  function login()
    io.write(concat{lang.Login or "Login",": "})
    params.uname = io.read("*l")
    if params.uname == "" then return end
    io.write(concat{lang.Password or "Password",": "})
    params.pw = io.read("*l")
    if params.pw == "" then return end
    params.mod = "login"
  end
  local m = self.menu:new("yoke.cli")
  self.menu[1] = m
  if content == "cli:login" then
    if not self.user or not self.user.id then
      print(menu)
      m.add("Login",function() login() end)
    end
  else
    if content and content ~= "" then print(content) end

    if items.start and items.start[1] then
      m.add(concat{lang[items.start[2]] or items.start[2] or "start","\n"},
        function() params.mod = items.start[1] end)
    end

    for k,v in ipairs(menu == "cli:menu" and items or type(menu) == "table" and menu or {}) do
      if v[2] then --todo
        m.add(concat{lang[v[2]] and lang[v[2]] ~= '' and lang[v[2]] or v[2],"\n"},function(id,nm)
          if nm ~= "" then params.name = nm end
          params.mod = v[1]
        end)
      end
    end

    if menu == "cli:menu" then
      m.add("Login",function() login() end)
    elseif self.user.login then
      m.add(self.user.login,function () params.mod = "metas" end)
      m.add('Login',function () login() end)
    end
    if self.user and self.user.admin then
      m.add("Admin",function()
        params.mod = "users"
      end)
    end
  end
end

function db:list(clith,cli,nxt,smod,dtable,srecno)
  if not self.model then return end
  local th = {}
  local capt = {}
  for k,v in pairs(clith) do --labels
    local len = utf8.len(v[1])
    th[k] = v[1]..string.rep(' ',len < v[2] and v[2] - len or 0)
    capt[#capt+1] = th[k]
  end
  capt = #cli > 0 and concat{"\n\027[35m N) ",concat(capt," "),"\027[0m"} or ""
  local mod = smod or self.def.name --self.model
  local m = self.menu:new(concat{lang[self.Name] or self.Name,capt})
  self.menu[2]=m
  local items = {}

  for k,v in ipairs(cli) do -- v={oid,clirow}
    local tr = {}
    for col,val in pairs(v[2]) do -- values
      local len = utf8.len(val)
      local spaces = string.rep(' ',len < clith[col][2] and clith[col][2] - len or 0)
      tr[#tr+1] = val..spaces
    end
    tr = concat(tr," ").."\n"
    m.add(tr,function()
      --setmetatable(self,nil) -- prevent loop
      if params.cliref then
        params.cliref = v[1]     --refid
        params.refcli = v[2][1]  --list col 1
        return
      end
      params.recno = v[1]
      params.act = "show"
      params.mod = mod -- sublist or list
    end)
    items[#items+1] = v[1]
  end
  if nxt then
    m.add("Next:"..math.abs(nxt),function ()
      if smod and srecno then
        params.smod = smod
        params.recno = srecno
        params.act = "show"
      else
        params.act = "find"
      end
      params.mod = self.model
      params.shift = cli.shift
    end)
  end
  m.add(lang.Find or "Find",function(item,nm)
      params.shift = nil
      params.mod = mod
      params.act = "finder"
--      params.cliref = ""
      if nm and nm ~= "" and nm ~= "=" then
        params[dtable[1][1]] = nm
        params.act = 'find'
      else
        self:site()
      end
    end)
  m.add(lang.New or "New", function ()
    if smod and dtable.link and dtable.link.id then
      params[dtable.link.id] = srecno --  parent link recno todo
      if dtable.link.mod then
        params.refbase = self.def.mod --  parent link base
      end
    elseif smod and dtable.where then
      params[dtable.where.id] = srecno -- parent link recno
      if dtable.where.mod then
        params[dtable.where.mod] = self.mod
      end
    end

    params.act = "new"
    params.mod = mod

  end)
  if #cli > 0 then
    m.add(lang.Delete or "Delete",function(id,max)
      id,max = tonumber(id),tonumber(max)
      if id and items[id] and
        self.menu:confirm(concat{"Delete ?: ",id,max and ('-'..max) or '',' ',mod}) then
        if max then
          params.act = 'massdel'
          params.lookpos = {}
          for i=id,max do insert(params.lookpos,items[i]) end
        else
          params.act = "delete"
          params.recno = items[id]
        end
        params.mod = mod
      end
    end)
  end
--
  for k,v in ipairs(self.def.menu and self.def:menu() or {}) do
    m.add(lang[v[2]] or v[2],function()
      params.mod = v[1]
      for kk,vv in pairs(v[3] or {}) do params[kk] = vv end
    end)
  end
--
  return "Ok"
end

function db:find(cli)
  params = {mod=params.mod}
  local m = self.menu:new(lang.Find or "Find")
  local id
  for k,v in ipairs(cli) do
    local vnm = v[2]
    local vid = v[1]
    m.add((lang[vnm] or vnm).."\n",function()
      if v.ht == "SELECT" then
        local mm = self.menu:new(lang[vnm] or vnm)
        if v.rt then
          local name = v.rf and v.rf[1][1] or "name"
          local qry = v.qry or concat{"select rowid,",name," as name from ",v.rt,
          v.wh and (" where "..v.wh) or ""," order by ",name}
          for rowid,nm in self.conn:urows(qry) do
            mm.add((lang[nm] or nm).."\n",function()
              id = vid
              params[vid] = rowid
            end)
          end
        else
          for kk,vv in pairs(v.rf) do
            mm.add(lang[vv[2]] or vv[2],function()
              params[vid] = vv[1]
              id = vid
            end)
          end
        end
        mm.loop()
      else
        local nm = io.read("*l")
        if nm ~= "" then
          params[vid] = nm
          id = vid
        end
      end
    end)
  end
  m.add("All",function() id = 'act' end)
  m.loop()
  params.act = 'find'
  return id
end

function db:edit(cli,name,val,v,nm,sub)
    local value = ""
    local vname
    if v.ht == "TEXTAREA" or v.ht == "HTML" then
      value = self.menu:ed(name,params[sub..v[1]] or val or "")
    elseif v.ht == "SELECT" and (not v.rt or v.rf.ht == "SHOW") then
      local m = self.menu:new(name)
      for k,vv in pairs(type(v.rf)=="table" and v.rf or self.conf[v.rf]) do
        m.add(lang[vv[2]] or vv[2] or vv[1],function() value = vv[1]
          vname = lang[vv[2]] or vv[2] or vv[1]
        end)
      end
      m.loop()
      if value == "" then self.menu.back = nil end
    elseif v.rt and (v.ht == "REF" or v.ht == "SELECT") then
      params.cliref=""
      params.mod = v.rt
      if nm and nm ~= "" and nm ~= "=" then params[v.rf[1][1]] = nm end
--    list:run(nm == "=" and pars[v.id..(v.ht=="REF" and "Id" or "")]  or nil)
      local name = self.model
      self:site()
      self.menu[2].loop()
      value = params.cliref
      vname = params.refcli --todo name,note
      self.model = name --root.model = name
      params = {}
    elseif v.ht ~= "SHOW" then
      io.write(concat{name,":",(val or ""),"\n"})
      value = io.read("*l")
    end
    if value then
      cli.save = true
      return value,vname
    end
    return false
end

function db:view(cli,recno,dform)
    --params.shift = nil
  local m = self.menu:new(lang[self.Name] or self.Name)
  self.menu[2] = m
    --name,value,vrow,sub,val
  for k,v in ipairs(cli) do
      local len = utf8.len(v[1])
      local label = concat{string.rep(' ',len < 18 and 18 - len or 0),v[1]}
      m.add(format("\027[35m%s:\027[0m %s\n",label,v[2] or "?"),
        function (id,nm)
          local val,vname = self:edit(cli,v[1],v[2],v[3] or {},nm,v[4] or "")
          cli.save = true
          if val then
            v[5] = val
            v[2] = vname or val
            self:view(cli,recno,dform)
          end
        end)
  end

  if cli.save or params.act == 'new' then
      local model = params.mod or self.model --todo check after deep sub models
      if params.act == new then model = self.model end
      local items = dform.submit or {{model,"Save",{act='update'}}}
      if #items == 0 then items = {items} end
      for i,item in ipairs(items) do
        local mod,act,val = item[1],item[3].act,item[2]
        m.add(lang[val] or val,function ()
          for k,v in pairs(cli.hidden or {}) do params[k] = v end
          for k,v in ipairs(cli) do
            params[concat{v[4] or "",v[3] and v[3][1] or ""}]=v[5]
            if v[3] and v[3].ht == "REF" then
              params[v[4]..v[3][1].."Id"] = v[5]
            elseif v[3] and (v[3].ht == "DATE" or v[3].ht == "DATETIME") then
              params[v[4]..v[3][1]] = v[2]
            elseif v[3] and v[3].ht == "CHECKBOX" then
              if tonumber(v[2]) == 1 and v[3].id then
                params[v[3].id] = params[v[3].id] or {}
                insert(params[v[3].id],v[3][1])
              end
            end
          end
          params.mod = mod
          params.act = act
          params.recno = recno
          cli.save = nil
        end)
      end
  end
  if recno and (tonumber(recno) or 0)  > 0 then
      m.add(lang.Delete or "Delete",function (id)
        if self.menu:confirm(concat{"Delete ?: ",recno,",",self.model}) then
          params.mod = self.model
          params.recno = recno
          params.act = "delete"
        end
      end)
      if not cli.save then
        if cli.menu then -- off new todo
          for k,v in pairs(cli.menu) do
            if not v.ext then
              m.add(lang[v[2]] or v[2],function()
                params.mod = v[1]
                for key,val in pairs(v[3]) do params[key] = val end
              end)
            end
          end
        end
        for i,row in ipairs(dform.list or {}) do
          local name,frm = row[1],row[2]
          if frm and frm.link then
--          local qry = {"select nullif(count(*)>0,0) from ",name}
            local qry = {"select count(*) from ",name}
            for i,join in ipairs(frm.join or {}) do
              qry[#qry+1] = " left join " .. join
            end
            local And = " where "
--          insert(qry,concat{And,frm.where.id,"=",recno})
            if type(frm.link.id) == "string" then
              insert(qry,concat{And,frm.link.id,"=",recno})
            elseif type(frm.link.id) == "table" then
              insert(qry,concat{And,"("})
              local Or = ""
              for _,fld in ipairs(frm.link.id) do
                insert(qry,concat{Or,fld,"=",recno})
                Or = " or "
              end
              insert(qry,")")
            end
--
            And = " and "
            if frm.link.mod then
              insert(qry,concat{And,frm.link.mod,"=","'",self.model,"'"})
            end
            for cnt in self.conn:urows(concat(qry)) do
              m.add(concat{lang[frm.id] or frm.id or self.model,cnt > 0 and (":"..cnt) or ""}, function()
                params.mod = self.model -- mod
                params.smod = name     -- modsub
                params.recno = recno   -- mod recno
                params.act = "show"
              end)
            end
          end
        end
      end
  end
  if cli.save and params.act ~= "update" then m.loop() end
end

return db
